export * from '@storybook/vue3';
export { DecoratorFunction, Meta, Preview, StoryFn, StoryObj, VueRenderer } from '@storybook/vue3';
import { StorybookConfig as StorybookConfig$1 } from '@storybook/types';
import { FrameworkOptions } from '@storybook/vue3-vite';
import { StorybookConfigVite } from '@storybook/builder-vite';

type FrameworkName = '@storybook-vue/nuxt'
type BuilderName = '@storybook/builder-vite'

type StorybookConfigFramework = {
  framework:
    | FrameworkName
    | { name: FrameworkName; options: FrameworkOptions }
  core?: Omit<StorybookConfig$1['core'], 'builder'> & {
    builder?:
      | BuilderName
      | {
          name: BuilderName
          // eslint-disable-next-line @typescript-eslint/no-explicit-any
          options?: Record<string, any>
        }
  }
}

/**
 * The interface for Storybook configuration in `main.ts` files.
 */
type StorybookConfig = Omit<
  StorybookConfig$1,
  keyof StorybookConfigVite | keyof StorybookConfigFramework
> &
  StorybookConfigVite &
  StorybookConfigFramework

export type { StorybookConfig };
